//
// hash.h
//

#ifndef __hash_h
#define __hash_h

#include "btree.h"

struct hash
	{
	struct btree **buckets;
	unsigned int slots;
	unsigned int elements;
	};

struct hash *hash_init(unsigned int);
int hash_set(struct hash *, const char *, unsigned int);
struct btree_node *hash_get(struct hash *, const char *);
unsigned int hash_decompose(struct hash *, const char *);

void hash_free(struct hash *);

#endif
